package jiaocaiziliao

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/education/src/jiaocaiziliao/model"
	"shylinux.com/x/enterprise/src/guanlixitong"
)

type Table struct {
	guanlixitong.Table
	list string `name:"list issuer_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.USER_ISSUER_ROLE:
		s.InputsListRole(m, UserIssuerRoleList, arg...)
	case model.ISSUER_TYPE:
		s.InputsList(m, IssuerTypeList, arg...)
	case model.DOCUMENT_TYPE:
		s.InputsList(m, DocumentTypeList, arg...)
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		switch key {
		case model.USER_ISSUER_ROLE:
			value = UserIssuerRole(kit.Int(value)).String()
		case model.ISSUER_TYPE:
			value = IssuerType(kit.Int(value)).String()
		case model.DOCUMENT_TYPE:
			value = DocumentType(kit.Int(value)).String()
		}
		return value
	})
	return s.Table.RewriteAppend(m)
}
func (s Table) CheckRole(m *ice.Message, arg ...string) *ice.Message {
	role := UserIssuerRole(kit.Int(m.Cmd(userIssuer{}, s.Select, m.OptionSimple(model.ISSUER_UID, model.USER_UID)).Append(model.ROLE)))
	m.WarnNotRight(!kit.IsIn(role.String(), append(arg, UserIssuerCreator.String())...), role.String())
	return m
}
func (s Table) recordEvent(m *ice.Message, info string, arg ...string) {
	s.Table.RecordEvent(m, m.Option(model.ISSUER_UID), info, kit.Select(m.Option(model.UID), arg, 0))
}
func (s Table) recordEventWithName(m *ice.Message, info string, arg ...string) {
	s.Table.RecordEventWithName(m, m.Option(model.ISSUER_UID), info)
}

type Tables struct{ Table }

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}
